# tools.py
#
# Some tools used in other modules.
#
# Jon Saenz, while at UCLA, 19990816
# 
# Copyright (C) 2000, Jon Saenz, Juan Zubillaga and Jesus Fernandez
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, version 2.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
from Numeric import *

def pyclimateversion():
	return "1.1"

def unshape(arraynd, spacelast=1):
	"""Crashes all but the first dimension of an array in one.

  unshape(arraynd)
  arraynd -- N-dimensional NumPy array (N>=2)
  spacelast -- A bit indicating if the space dimensions are all but 
               the first (this is the default; spacelast=1) or all
               but last
  
  Returns a tuple (array2d, oldshape)
  array2d -- 2-dimensional array with the first dimension as the 
             input one and the remaining ones compresed in the 
             second dimension.
  oldshape -- Is the shape (a tuple) of <arraynd>. It'll be needed to 
              recover the shape with <deunshape()>.
  """
	arraynd = array(arraynd)
	oldshape = arraynd.shape
	if spacelast:
		taillen = multiply.reduce(oldshape[1:])
		arraynd.shape = (oldshape[0], taillen)
	else:
		headlen = multiply.reduce(oldshape[:-1])
		arraynd.shape = (headlen, oldshape[-1])
	return arraynd, oldshape

def deunshape(array2d, oldshape):
	"""Recover the dimensions of an <unshape()>-ed array.

  deunshape(array2d, oldshape)
  array2d -- 2-dimensional array which dimensions are to be recovered.
  oldshape -- The shape (a tuple) the array must be returned with.

  Returns the array with the specified shape.
  """
	array2d = array(array2d)
	array2d.shape = oldshape
	return array2d 

