# writedat.py
# A simple ascii data writer. 
# 
# Copyright (C) 2000, Jesus Fernandez, Jon Saenz and Juan Zubillaga
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, version 2.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# jff20010402

from Numeric import *

def buildcomplex(c):
  return " %g,%g"%(c.real,c.imag)

def writedat(fname, matrix, header="", formatstring="%g "):
  theshape=matrix.shape
  tcode=matrix.typecode()
  iscomplex=(tcode==Complex32 or tcode==Complex64)
  if len(theshape)>2:
	raise WrongWriteDimensions(len(theshape))
  ofile = open(fname, "w")
  if len(header)>0:
    ofile.write(header)
    if header[-1]!='\n':
	ofile.write("\n")
  records=matrix.shape[0]
  if iscomplex:
    if len(matrix.shape) == 2:
      for i in range(records):
        for j in range(matrix.shape[1]):
          ofile.write("%s"%buildcomplex(matrix[i,j]))
        ofile.write("\n")
    else:
      for i in range(records):
          ofile.write("%s"%buildcomplex(matrix[i]))
          ofile.write("\n")
  else:
    if len(matrix.shape) == 2:
      for i in range(records):
        for j in range(matrix.shape[1]):
          ofile.write(formatstring%matrix[i,j])
        ofile.write("\n")
    else:
      for i in range(records):
          ofile.write(formatstring%matrix[i])
          ofile.write("\n")
  ofile.close()

# jff20010407
